#include <iostream.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>
#include <unistd.h>
#include <stdlib.h>
#include <fstream.h>
#include "suffix_tree.h"

ofstream StatisticsFileStream;
#define DIR "/mjolnir/thomas/research/display"
#define PATHFILE "/tmp/path_file"
#define SUBFILE "/tmp/sub_file"
#define SUPERFILE "/tmp/sup_file"
#define DOCSFILE "/tmp/docs_file"

#define NUM_TERMS 4

int compare_ints(const int *a, const int *b) {
  return (int)(*a - *b);
}

int main(int argc, char *argv[]) {
  char *fname = new char[strlen(DIR) + strlen("/create_statistics.log") + 1];
  sprintf(fname, "%s/create_statistics.log", DIR);
  StatisticsFileStream.open(fname, ios::out | ios::app);
  StatisticsFileStream.setf(ios::fixed, ios::floatfield);
  delete []fname;

  int threshold = atoi(argv[1]);
  char *client_id = argv[2];

  char path[200];
  int path_len, num_docs, path_fd, file_off, docs_fd;

  char *path_file = new char[strlen(PATHFILE) + strlen(client_id) + strlen(".1") + 1];
  sprintf(path_file, "%s%s.1", PATHFILE, client_id);
  char *sub_file = new char[strlen(SUBFILE) + strlen(client_id) + strlen(".1") + 1];
  sprintf(sub_file, "%s%s.1", SUBFILE, client_id);

  char *docs_file = new char[strlen(DOCSFILE) + strlen(client_id) + 1];
  sprintf(docs_file, "%s%s", DOCSFILE, client_id);

  suffix_tree_node *root = NULL;
  int *docids, *docrks;

  path_fd = open(path_file, O_CREAT | O_WRONLY, S_IREAD | S_IWRITE);
  docs_fd = open(docs_file, O_CREAT | O_WRONLY, S_IREAD | S_IWRITE);

  file_off = 0;
  while(!cin.eof()) {
    cin >> path;
    if(!cin || cin.eof()) break;

    cin >> num_docs;
    path_len = strlen(path);

    // generate docids
    docids = new int[num_docs];
    docrks = new int[num_docs];
    for(int i=0; i<num_docs; i++) {
      docids[i] = rand() % 1000;
      docrks[i] = rand() % (int) (pow(2, NUM_TERMS));
    }

    // sort the array
    qsort(docids, num_docs, sizeof(int), compare_ints);

    // print distinct docids
    int actual_count = 0;
    int last_seen = -1;
    for(int i=0; i<num_docs; i++) {
      if(docids[i] != last_seen) {
	last_seen = docids[i];
	//cout << docids[i] << endl;
	if(write(docs_fd, (char *)&docids[i], sizeof(int)) < sizeof(int)) return 0;
	if(write(docs_fd, (char *)&docrks[i], sizeof(int)) < sizeof(int)) return 0;
	actual_count++;
      }
    }

    delete []docids;
    delete []docrks;

    //cout << path << " " << file_off << " " << actual_count << endl;

    if(write(path_fd, (char *)&path_len, sizeof(int)) < sizeof(int)) return 0;
    if(write(path_fd, (char *)path, path_len) < path_len) return 0;
    if(write(path_fd, (char *)&file_off, sizeof(int)) < sizeof(int)) return 0;
    if(write(path_fd, (char *)&actual_count, sizeof(int)) < sizeof(int)) return 0;

    insert_path(root, "", path, "", file_off, actual_count);
    file_off += (actual_count * 2 * sizeof(int));
  }
  close(path_fd);
  close(docs_fd);

  if(root) print_to_file(sub_file, root);
  //if(root) print_html(1, threshold, root);
  int init_view = 1;
  int max_sup_level = 0, max_sub_level = 0;
  int sub_node_count = 0, sup_node_count = 0;
  print_html_trees(init_view, threshold, NULL, root, client_id,sub_node_count, max_sub_level, sup_node_count, max_sup_level);

  //if(root) print_text(root);
  delete_suffix_tree(root);
  delete []path_file;
  delete []sub_file;
  delete []docs_file;
  StatisticsFileStream.close();
  return 0;
}
