#include <iostream.h>
#include <fstream.h>
#include "../index/common.h"
#include <assert.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int get_url(int fd, int docId, char *url)
{
  if(lseek(fd, URL_SIZE * docId, SEEK_SET) < 0)
    return -1;
  
  int nbytes = read(fd, url, URL_SIZE);
  if(nbytes < URL_SIZE)
    return -1;
  
  url[URL_SIZE] = 0;
  
  return 0;
}

void print_html_urls(char *merge_file_, int start_, int batch_size_, int num_docs_, 
		     char *url_file_, int phrase_count, char *client_id) {
  ifstream            in;
  int                 seek_offset = start_ * 2 * sizeof(int);
  int                 temp_doc_id, temp_doc_rank, fd = open(url_file_, O_RDONLY);
  char                url[URL_SIZE+1];

  in.open(merge_file_);
  in.seekg(seek_offset);
  int count = 0;
  cout << "<center>" << endl;
  cout << "<table border=\"1\">" << endl;
  cout << "<tr>" << endl;
  cout << "<th colspan=\"1\">"
       << "Matching Terms"
       << "</th>" << endl;
  cout << "<th colspan=\"1\">"
       << "URL"
       << "</th>" << endl;
  cout << "</tr>" << endl;
  bool next_flag = false;
  bool prev_flag = false;
  if(start_ != 0) prev_flag = true;
  if(start_ + batch_size_ < num_docs_) next_flag = true;

  while(1) {
    in.read((char *)&temp_doc_id, sizeof(int));
    if(!in || in.eof()) break;
    in.read((char *)&temp_doc_rank  , sizeof(int));

    cout << "<tr>" << endl;
    assert(get_url(fd, temp_doc_id, url) == 0);
    cout << "<td> ";
    
    int position = 1;
    for(int i=0; i<phrase_count; i++) {
      if((temp_doc_rank & position) == position) cout << "X";
      else cout << "_";
      position *= 2;
    }

    cout << " [" << temp_doc_rank << "]";
    cout << " </td> ";     
    cout << endl;

    cout << "<td> ";
    cout << "<a href=\"http://" << url << "\">" << url << "</a>";
    cout << " </td> ";     
    cout << endl;

    count++;
    cout << "</tr>" << endl;
    if(count == batch_size_)       
      break;    
  }

  cout << "<tr>" << endl;
  cout << "<td> ";
  if(prev_flag) 
    cout << "<a href=\"http://mjolnir.cs.umd.edu:1975/cgi-bin/new_search?"
	 << "operation=traverse"
	 << "&start=" << (start_-batch_size_)
	 << "&batchsize=" << batch_size_
	 << "&numdocs=" << num_docs_
	 << "&phrasecount=" << phrase_count
	 << "&id=" << client_id
	 << "\"> Previous </a>";
  else 
    cout << "&nbsp;";
  cout << " </td>" << endl;
  cout << "<td> ";
  if(next_flag)
    cout << "<a href=\"http://mjolnir.cs.umd.edu:1975/cgi-bin/new_search?"
	 << "operation=traverse"
	 << "&start=" << (start_+batch_size_)
	 << "&batchsize=" << batch_size_
	 << "&numdocs=" << num_docs_
	 << "&phrasecount=" << phrase_count
	 << "&id=" << client_id
	 << "\"> More </a>";
  else 
    cout << "&nbsp;";
  cout << " </td>" << endl;
  cout << "</tr>" << endl;
  
  cout << "</table>" << endl;

  cout << "</center>" << endl;
  in.close();
  close(fd);
}
