#ifndef INDEX_H
#define INDEX_H

#include "LinearHash3.h"
#include "String.h"
#include "Int.h"
#include "key_file_record.h"
#include "InvertedFile5.h" /* NUM_BUCKETS, NUM_SLOTS, INIT_LEN */
#include "Time.h"
#include "Trie4.h"
#include <sys/time.h>
#include "List.h"

#define MAX_FILE_NAME_LEN 400
#define MAX_TRIE_SIZE 1000000

class Index {
  char *_fname;
  Trie* _dictionary;
  int _run_number;
  int _run;

  int  flush_dictionary();
  InvertedFile* create_inverted_file(int run_);
public:
  Index(char *fname_);
  ~Index();
  int  insert(char *key_, char *path_, int doc_id_, int word_pos_);
};

#endif
