#ifndef INT_H
#define INT_H
#include <fstream.h>

class Int {  
  int value;

public:
  /* constructors and destructor */
  Int(int = 0);
  Int(char*);
  Int(const Int&);
  ~Int();
  
  /* returns the key of */
  int get_key();
  int get_len() { return sizeof(int);} 
  static int get_max_len() { return sizeof(int); }

  char* toCharPtr() { 
    char *p = new char[sizeof(int)+1]; 
    memcpy(p, (char *)&value, sizeof(int)); 
    p[sizeof(int)] = 0; 
    return p; 
  }

  /* assignment operator */
  Int& operator = (const Int& other);

  Int operator - (const Int& other);
  Int operator + (const Int& other);

  /* relational operators */
  bool    operator <(const Int& other);
  bool    operator >(const Int& other);
  bool    operator ==(const Int& other);
  bool    operator >=(const Int& other);
  bool    operator <=(const Int& other);
  
  /* write operator */
  friend ostream& operator <<(ostream& out, Int object);
};
#endif
