#ifndef InvList_h
#define InvList_h

#include "string.h"
#include <iostream.h>
#include "List.h"
#include "Int.h"

typedef struct _dEntry {
  int doc_id;
  int word_pos;
  struct _dEntry *dNext;
} DEntry;

typedef struct _pEntry {
  char *pname;
  int count;
  DEntry *dFirst;
  DEntry *dLast;
  struct _pEntry* pNext;
} PEntry;

class InvList {
  PEntry    *_first;
  PEntry    *_curr_path_entry;
  DEntry    *_curr_doc_entry;
  int       _npaths;
  int       _print_len;
  int       _num_entries;
public:
  InvList(char *buf_=0, int len_=0);
  InvList(const InvList& other_);
  ~InvList();
  void     free();

  void     append(char *pname_, int doc_id_, int word_pos_);
  void     insert(char *pname_, int doc_id_, int word_pos_);
  void     remove(int doc_id_);
  int      get_print_len() const;
  int      get_num_entries() const;
  char*    toCharPtr() const;

  InvList& operator =(const InvList& other_);

  bool     isEmpty() const;
  void     goFirst();
  void     goNext();
  bool     isOffList() const;
  int      getFromCurrent(char *& pname_, int &doc_id_) const ;
  
  InvList  operator +(const InvList& other_);
  friend InvList adjacent(InvList &curr_, InvList &other_, int distance_);
  List<Int, int> condense() const;
  InvList  prune(char *path_) const;
};

#endif
