#ifndef INVERTED_FILE_H
#define INVERTED_FILE_H
#include "String.h"
#include "InvList.h"
#include "key_offset_record.h"
#include "Int.h"
#include "LinearHash3.h"
/*#include "HashTable.h"*/
#include "Time.h"

#define NUM_BUCKETS 4096 /* 1009 */
#define NUM_SLOTS 100 /*1000*/
#define BASIC_REC_SIZE 256

typedef struct FileHeader_ {
  int rec_size;
  int first;
  int end_of_file; /* offset used by the iterators */
} FileHeader;

typedef struct RecHeader_ {
  int free;
  int next;
  long sec;
  long usec;
} RecHeader;

class InvertedFile {
  char *_idString;
  char *_if_fname; /* name of inverted file */
  char *_if_iname; /* name of the index on the inverted file */
  int _fd; /* file descriptor for _if_fname */
  FileHeader _fheader; 
  bool _modified; /* Has the file header been modified? */
  int _rec_offset; /* Used by the iterators */

  int my_write(int fd_, char *ptr_, int len_);
public:
  InvertedFile(char *fname_, char *idString_ = "IF: ");
  InvertedFile(const InvertedFile& other);
  ~InvertedFile();
  
  int insert_record(String key_, const InvList &list_, Time time_);  
};

#endif
