
#include "List.h"

template <class listitem, class datakey>
List<listitem, datakey>::List() {
  first = curr = puppy = last = 0;
  count = 0;
}

template <class listitem, class datakey>
List<listitem, datakey>::List(const List<listitem, datakey>& obj) {
  first = curr = puppy = last = 0;
  (*this) = obj;
}

template <class listitem, class datakey>
List<listitem, datakey>::~List() {
  free();
}

template <class listitem, class datakey>
List<listitem, datakey>& List<listitem, datakey>::operator =(const List<listitem, datakey>& obj) {
  struct listNode<listitem> *mover;
  
  if (&obj != this) {
    this->free();
    mover = obj.first;
    while (mover != 0) {
      this->addToBack(mover->data);
      mover = mover->next;
    }
  }
  return *this;
}

template <class listitem, class datakey>
void List<listitem, datakey>::goFirst() {
  puppy = 0;
  curr = first;
}

template <class listitem, class datakey>
void List<listitem, datakey>::goLast() {
  if (isEmpty()) return;

  this->goFirst();
  while (curr->next != 0) {
    puppy = curr;
    curr = curr->next;
  }
}

template <class listitem, class datakey>
void List<listitem, datakey>::goNext() {
  assert(curr != 0);
  puppy = curr;
  curr = curr->next;
}

template <class listitem, class datakey>
bool List<listitem, datakey>::find(datakey key) {
  bool found = false;
  goFirst();
  while ( (!isOffList()) && ((curr->data).get_key() <= key) && (!found) ) {
    if ((curr->data).get_key() == key) found = true;
    else if((curr->data).get_key() < key) goNext();
  }
  return found;
}

template <class listitem, class datakey>
bool List<listitem, datakey>::isOffList() const {
  return (curr == 0);
}

template <class listitem, class datakey>
bool List<listitem, datakey>::isEmpty() const {
  return (first == 0);
}

template <class listitem, class datakey>
void List<listitem, datakey>::addToBack(listitem newd) {
  struct listNode<listitem> *temp;
  
  temp = new struct listNode<listitem>;
  temp->data = newd;
  temp->next = 0;
  
  if (isEmpty()) {
    first = temp;
    last  = temp;
  }
  else {
    last->next = temp;
    last       = temp;
  }	
  count++;
}
	
template <class listitem, class datakey>
void List<listitem, datakey>::insert(listitem newd) {
  struct listNode<listitem> *temp;
    
  if(find(newd.get_key()) == false) {
    temp = new struct listNode<listitem>;
    temp->data = newd;

    if(puppy) {
      temp->next    = curr;
      if(curr == 0) last = temp;
      puppy->next   = temp;
      curr          = temp;
    }
    else {
      temp->next = curr;
      if(first == 0) last = temp;
      first = temp;
      curr  = temp;
    }
    count ++;
  }
}

template <class listitem, class datakey>
void List<listitem, datakey>::insert_replace(listitem newd) {
  struct listNode<listitem> *temp;
  
  if(find(newd.get_key()) == false) {
    temp = new struct listNode<listitem>;
    temp->data = newd;
    
    if(puppy) {
      temp->next    = curr;
      if(curr == 0) last = temp;
      puppy->next   = temp;
      curr          = temp;
    }
    else {
      temp->next = curr;
      if(first == 0) last = temp;
      first = temp;
      curr  = temp;
    }
    count ++;
  }
  else {
    curr->data = newd;
  }
}

template <class listitem, class datakey>
bool List<listitem, datakey>::delFirst() {  
  if (isEmpty()) return false;
  
  if(last == first) last = 0;
  first = first->next;
  
  delete curr;
  goFirst();
  count --;
  return true;
}

template <class listitem, class datakey>
bool List<listitem, datakey>::delCurr() {
  if (isOffList()) return false;
  
  if (curr == first) return delFirst();
   if(curr == last) last = puppy;
  puppy->next = curr->next;
  delete curr;
  curr = puppy->next;
  count--;
  return true;
}

template <class listitem, class datakey>
listitem List<listitem, datakey>::getFromCurrent() const {
  return curr->data;
}

template <class listitem, class datakey>
List<listitem, datakey> List<listitem, datakey>::operator +(List<listitem, datakey>& other) {
  List<listitem, datakey> result;
  
  this->goFirst();
  other.goFirst();

  while( !(this->isOffList()) && !(other.isOffList()) ) {
    listitem currdata  = this->getFromCurrent();
    listitem otherdata = other.getFromCurrent();
    if(currdata.get_key() < otherdata.get_key())
      this->goNext();
    else if(currdata.get_key() > otherdata.get_key())
      other.goNext();
    else {
      result.addToBack(currdata);

      this->goNext();
      other.goNext();
    }
  }
  return result;
}

template <class listitem, class datakey>
List<listitem, datakey>& List<listitem, datakey>::operator -(List<listitem, datakey>& other) {
  this->goFirst();
  other.goFirst();
  while(!(this->isOffList()) && !(other.isOffList()) ) {
    find(((other.curr)->data).get_key());
    this->delCurr();
    other.goNext();
  }
  return *this;
}

template <class listitem, class datakey>
List<listitem, datakey>& List<listitem, datakey>::merge(List<listitem, datakey>& other) {
  other.goFirst();
  this->goFirst();
  while(!other.isOffList()) {
    listitem data = other.getFromCurrent();
    this->insert(data);
    other.goNext();
  }
  
  return *this;
}

/*
template <class listitem, class datakey>
void List<listitem, datakey>::printList(ostream& out) {
  this->goFirst();
  while (!(this->isOffList())) {
    out << curr->data << " ";
    this->goNext();
  }
  out << endl;
}

*/
template <class listitem, class datakey>
void List<listitem, datakey>::free() {
  struct listNode<listitem> *temp;

  curr   = first;
  while(curr) {
    temp = curr;
    curr = curr->next;
    delete temp;
  }
  first = last = curr = puppy = 0;
  count = 0;
}



