#ifndef String_h
#define String_h
    
//STRING in the abstract comments denotes the "current object."

#include <iostream.h>

class String {
    static int max;    
    int size;
    char* data;
    
public:
    String(char* init="");
        //abs: copy argument character String (terminated by '\0') into STRING 
    String(const String&);
        //abs: copy argument String into STRING
     ~String();
        //abs: delete STRING
    
    String get_key() { return *this; }

    char *toCharPtr();
	
    int   len() const { return size-1; }
    
    int   get_len() const { return size-1;}
    
    static int get_max_len() { return max; }

    String& operator = (const String&);
        //abs: STRING = argument String
    String& operator = (const char*); 
        //abs: STRING = argument character String
    int operator < (const String&) const;
        //abs: return (STRING < argument String)
    int operator > (const String&) const;
        //abs: return (STRING > argument String)
    int operator == (const String&) const;
        //abs: return (STRING == argument string)
    int operator <= (const String&) const;
        //abs: return (STRING <= argument String)
    int operator >= (const String&) const;
        //abs: return (STRING >= argument String)
    friend istream& operator >> (istream&, String&);
        //abs: argument istream object == characterstring & otherinput
        // --> argument istream object = otherinput, 
        //     argument string = characterstring
    friend ostream& operator << (ostream&, const String); 
        //abs: argument ostream object = original output -->
        // --> argument ostream object = original output 
        //     & argument string
private:
    void free();
        //abs: deallocate STRING
};

#endif

