#include "Time.h"
#include <string.h> // memcpy

Time::Time(char *ptr_=0) {
  if(ptr_) {
    memcpy((char *)&_sec, ptr_, sizeof(long));
    memcpy((char *)&_usec, ptr_+sizeof(long), sizeof(long));
  }
  else {
    _sec = _usec = 0;
  }
}

Time::Time(long sec_, long usec_) {
  _sec = sec_;
  _usec = usec_;
}

Time::Time(const Time& other_) {
  _sec = other_._sec;
  _usec = other_._usec;
}

Time::~Time() {
}

char* Time::toCharPtr() {
  char *buf = new char[sizeof(long)+ sizeof(long)];
  memcpy(buf, (char *)&_sec, sizeof(long));
  memcpy(buf+sizeof(long), (char *)&_usec, sizeof(long));
  return buf;
}

int Time::get_len() {
  return (2*sizeof(long));
}

int Time::get_max_len() {
  return (2*sizeof(long));
}

bool Time::operator ==(const Time& other_) {
  return(_sec == other_._sec && _usec == other_._usec);
}

bool Time::operator <=(const Time& other_) {
  return(_sec < other_._sec || (_sec == other_._sec && _usec <= other_._usec));
}

bool Time::operator >=(const Time& other_) {
  return(_sec > other_._sec || (_sec == other_._sec && _usec >= other_._usec));
}

bool Time::operator <(const Time& other_) {
  return(_sec < other_._sec || (_sec == other_._sec && _usec < other_._usec));
}

bool Time::operator >(const Time& other_) {
  return(_sec > other_._sec || (_sec == other_._sec && _usec > other_._usec));
}

ostream& operator<<(ostream& out_, Time t_) {
  out_ << t_._sec << ":" << t_._usec;
  return out_;
}

Time& Time::operator=(const Time& rhs_) {
  _sec = rhs_._sec;
  _usec = rhs_._usec;
  return *this;
}

