#include "UrlDocMap.h"
#include <strings.h>
#include <assert.h>
#include "url_docid_record.h"
#include "InvertedFile5.h"

#define REC_LEN     ((URL_SIZE) + sizeof(int))

extern ofstream GLOBAL_logFileStream;

UrlDocMap::UrlDocMap(char *fname_) {
  _fname = new char[strlen(fname_) + 1];
  strcpy(_fname, fname_);
  _index = new LinearHash<String, Int, url_docid_record>(_fname, NUM_BUCKETS, NUM_SLOTS, REC_LEN, "HT.urls");
}

UrlDocMap::UrlDocMap(const UrlDocMap& other_) {
  _fname = new char[strlen(other_._fname) + 1];
  strcpy(_fname, other_._fname);
  _index = new LinearHash<String, Int, url_docid_record>(_fname, NUM_BUCKETS, NUM_SLOTS, REC_LEN, "HT.urls");
}

UrlDocMap::~UrlDocMap() {
  delete _index;
  delete []_fname;
}

int UrlDocMap::insert(String url_, Int docid_, double &cpu_time, double &disk_time) {
  url_docid_record item = url_docid_record(url_, docid_);
  return _index->insert(item, cpu_time, disk_time);
}

int UrlDocMap::remove(String url_) {
   return _index->remove(url_);
}

int UrlDocMap::find(String url_, Int &docid_, bool &found_) {
  if(_index->find(url_, docid_, found_) == -1) {
    GLOBAL_logFileStream << "UrlDocMap: " << "find; hash table find failed" << endl; 
    return -1;
  }
  return 0;
}

int UrlDocMap::flush_to_disk() {
  return _index->flush_to_disk();
}

