#include "doc_rank.h"

doc_rank::doc_rank(int d, int w) {
  document_id = d;
  rank = w;
}

doc_rank::doc_rank(const doc_rank& other) {
  document_id  = other.document_id;
  rank = other.rank;
}

doc_rank::~doc_rank() {
}

int doc_rank::get_key() {
  return document_id;
}

doc_rank& doc_rank::operator =(const doc_rank& other) {
  document_id = other.document_id;
  rank = other.rank;
  return *this;
}

bool doc_rank::operator == (const doc_rank& other) {
  return (document_id == other.document_id && rank == other.rank);
}

bool doc_rank::operator <  (const doc_rank& other) {
  return (document_id < other.document_id || (document_id == other.document_id && rank < other.rank));
}

bool doc_rank::operator >  (const doc_rank& other) {
  return (document_id > other.document_id || (document_id == other.document_id && rank > other.rank));
}

bool doc_rank::operator <= (const doc_rank& other) {
  return (*this < other || *this == other);
}

bool doc_rank::operator >= (const doc_rank& other) {
  return (*this > other || *this == other);
}

ostream& operator <<(ostream& out, doc_rank dw) {
  out << dw.document_id << ":" << dw.rank;
  return out;
}


