#ifndef doc_rank_h
#define doc_rank_h

#include <ostream.h>

class doc_rank {
private:
  int document_id;
  int rank;
public:
  /* constructors and destructor */
  doc_rank(int=0, int=0);
  doc_rank(const doc_rank &other);
  ~doc_rank();
  
  int get_key();
  int get_document_id() { return document_id; }
  int get_rank() { return rank; }

  /* assignment operator */
  doc_rank& operator = (const doc_rank& other);
  
  /* relational operators */
  bool operator == (const doc_rank& other);
  bool operator <  (const doc_rank& other);
  bool operator >  (const doc_rank& other);
  bool operator <= (const doc_rank& other);
  bool operator >= (const doc_rank& other);
  
  friend ostream& operator <<(ostream& out, doc_rank dw);
};
#endif
