#include "Indexer.h"
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>
#include <errno.h>
#include <istream.h>

extern ofstream GLOBAL_logFileStream;
ofstream statFileStream;
extern int errno;

// function: sys_index
// args: 
//      fname_ : string prepended to names of files created by the program
//      infile_: file containing names of files to be indexed
//               (each file name must have length <= MAX_FILE_NAME_LEN)
//      prefix_: maximal prefix common to all file names in infile_
//               (file name - prefix_ = url)
int sys_index(char *fname_, char *infile_, char *prefix_) {
  ifstream in(infile_);

  char *fname = new char[strlen(fname_) + strlen(".index.stats") + 1];
  sprintf(fname, "%s.index.stats", fname_);
  statFileStream.open(fname);
  delete []fname;

  char timeString[100];
  time_t clock_time = time(NULL);
  cftime(timeString, "on %e %b %Y at %T", &clock_time);
  GLOBAL_logFileStream << "index: started " << timeString << endl;

  Indexer::init(fname_);

  char fileToIndex[MAX_FILE_NAME_LEN];
  in.getline(fileToIndex, MAX_FILE_NAME_LEN, '\n');

  if(!in) {
    fileToIndex[MAX_FILE_NAME_LEN-1] = 0;
    GLOBAL_logFileStream << "index: File name too long - " << fileToIndex << endl;
    exit(0);
  }

  while(!in.eof()) {    
    if((strlen(fileToIndex) -  strlen(prefix_)) >= URL_SIZE) {
    }
    else {
      char url[URL_SIZE];
      memset(url, ' ', URL_SIZE);  
      strcpy(url, fileToIndex + strlen(prefix_));

      int exitcode;
      if((exitcode = Indexer::parseAndIndex(fileToIndex, url)) == -1) 
	statFileStream << fileToIndex << ": file corrupted - exitcode = " << exitcode << endl;
    }

    in.getline(fileToIndex, MAX_FILE_NAME_LEN, '\n');
    
    if(!in || in.eof()) break;
  }

  // delete the parser
  Indexer::cleanup();


  in.close();

  clock_time = time(NULL);
  cftime(timeString, "on %e %b %Y at %T", &clock_time);
  GLOBAL_logFileStream << "index: over " << timeString << endl;

  statFileStream << endl;

  statFileStream.close();
  return 0;
}
